# 为Monster Hunter World - More Auto Shouts 制作的简易Fsm ID 表
为了方便用户编辑，现笔者决定制作一个简易fsm表，用于给用户以参考。
## 注：本文仅收纳大部分玩家希望使用的fsm，*不包含所有的动作*（比如拔刀态走路，普通攻击等触发较为频繁且无特殊意义的动作之类的不会写在里面）
### 大剑（武器编号：0）
#### 蓄力攻击动作
```text
id = 85:拔刀斩，蓄力斩蓄力动作
id = 65:蓄力斩斩击动作
id = 86:强蓄力斩蓄力动作
id = 74:强蓄力斩斩击动作
id = 102:真蓄力斩蓄力动作
id = 78:真蓄力斩出刀动作，包括强击未命中时的后续动作。若真蓄垫刀命中则fsmid变为135/136/137，后续为真蓄强击动作
id = 135:一蓄真蓄力斩强击动作
id = 136:二蓄真蓄力斩强击动作
id = 137:三蓄真蓄力斩强击动作
```
#### 防御类动作
```text
id = 79, 80:铁山靠，蓄靠和滚靠是79，强蓄真蓄靠是80
id = 87，88，89：防御动作，87是防御起手，88是防御姿态，89是解除防御
id = 11，12：拔刀防御动作，11是站姿防御，12是移动中防御
```
#### 其他动作
```text
id = 81：飞身跃入横扫斩
id = 66：横扫斩
id = 75：强化横扫斩
id = 71：横拍
id = 69：上捞斩
id = 73：踢
```
#### 钩爪派生，软化动作，强化射击等
```text
id = 114：强化射击
id = 42：软化动作
id = 105：软化落地动作
```
### 片手剑（武器编号：1）
#### 主要输出动作
```text
id = 123：飞身跃入斩
id = 124：强化射击派生的飞身跃入斩
id = 125，127，129：jr非红刀三段，125第一段，127第二段，129第三段
id = 126，128，130: jr红刀三段（精准连击），126第一段，128第二段，130第三段
id = 131，132：jr终结插拔，131为非红刀插拔，由fsmid = 129击中怪物派生；132为红刀插拔，由fsmid = 130击中怪物派生
id = 133, 134：jr插拔落地，133为非红刀插拔落地，134为红刀插拔落地
id = 91：后撤蓄力斩
id = 99：后撤蓄力斩命中动作
id = 100：后撤蓄力斩命中起跳
id = 101：空中盾砸
id = 102：盾砸落地
```
#### 防御类动作
```text
id = 75：防御起手，防御结束77，防御行走78
id = 76：防御中
id = 77：防御结束
id = 78：防御行走
id = 11：拔刀防御动作
id = 79：防御斩
```
#### 蹭刀类动作
```text
id = 13：空中跳跃斩（骑乘值较高）
id = 29：跳跃斩落地
id = 72：剑盾连击
id = 83：回转斩击
id = 86，89，87：肘击三连
```
#### 钩爪派生，特殊软化动作，强化射击等
```text
id = 65：翻滚派生钩爪上捞
id = 47：强化射击
id = 68：钩爪上捞命中
id = 67：钩爪上捞未命中落地动作
```
### 双刀（武器编号：2）
#### 鬼人化开关
```text
id = 11：鬼人化
id = 12：移动中拔刀鬼人化
id = 97：空中鬼人化
id = 98：站姿鬼人化解除，移动时解除鬼人化无人物动作，故无特殊fsm
id = 99：在某一动作后派生鬼人化解除
```
#### 主要输出动作
```text
id = 81：鬼人六连斩
id = 92：鬼人乱舞
id = 90：鬼人连斩
id = 94：鬼人化下鬼人突进连斩
id = 95：鬼人强化下鬼人突进连斩
id = 86：回旋斩（鬼人化右键(Y)派生第二段）
id = 88：二回旋斩（鬼人化右键(Y)派生第三段）
```
#### 空中派生动作
```text
id = 139，140：非鬼人化，鬼人化的上墙动作
id = 69：空中回转乱舞
id = 71，114，115：空中回转乱舞终结以及落地动作（114为非鬼人化，115为鬼人化）
id = 8，137：沿斜坡向下的滑行动作（顺斩），可派生空中回转乱舞（8为非鬼人化，137为鬼人化）
id = 133，136：滑行结束（停止按方向键停止于斜坡上）
id = 132，135：滑行结束（因地形原因停止滑行）
id = 126：搓背
id = 127：搓背终结
id = 129：搓背落地
```
#### 钩爪派生，特殊软化动作，强化射击等
```text
id = 146，147，148，149：四向强化射击回避（146，前，147，左，148，右，149，后）
id = 162：鬼人化右键连段钩爪派生
id = 163：钩爪派生命中的上身动作
id = 164：钩爪派生上身后的特殊软化攻击
id = 165：钩爪派生软化落地
id = 42：普通钩爪上身软化动作
id = 150：普通钩爪上身软化后的落地动作
```
#### 回避类动作
```text
id = 105：鬼人化自由态回避（默认朝着你的方向）
id = 106，107，108，109：鬼人化四向滑步回避（106，前，107，左，108，右，109，后）
```
### 太刀（武器编号：3）
#### 居合
```text
id = 98：特殊纳刀中（正在将刀收进刀鞘）
id = 99：特殊纳刀完成（已经将刀收进刀鞘准备居合）
id = 100：特殊纳刀转为正常纳刀
id = 101：居合拔刀斩（小居）
id = 102：居合拔刀气刃斩（大居）
```
#### 登龙动作拆分
```text
id = 87：气刃突刺
id = 89：气刃突刺命中时的起跳动作
id = 90：气刃突刺命中，起跳后在空中举刀的动作
id = 91：气刃兜割的下劈动作
id = 92：气刃兜割的落地动作
```
#### 气刃相关
```text
id = 68：三段气刃斩
id = 69：气刃大回旋
id = 86：看破斩（见切）
id = 75：空中三段气刃斩

```
#### 强化射击
```text
id = 104，105，106：气刃斩派生的强化射击（104向前，105向左，106向右，向后）
```
### 大锤（武器编号：4）
#### 终结技
```text
id = 87：压迫（左键连按终结技，有上捞判定）
id = 96，129：蓄力返挥（92无超蓄力，129有超蓄力）
id = 93，130：蓄力压迫（93无超蓄力，130有超蓄力，有上捞判定）
id = 94，131：蓄力敲打（94无超蓄力，131有超蓄力）
id = 95：大陀螺（回转挥旋）
id = 99：回旋强压迫（空中三蓄落地派生，大陀螺转三圈后派生）
```
#### 右键民工五连拆分
```text
id = 77，78，79，80：敲打四个阶段的起手动作
id = 82，83，84，85：敲打四个阶段的命中反馈动作
id = 81：敲打终结
```
#### 斜坡，空中派生
```text
id = 132：蓄力时上墙
id = 133，115：空中回转攻击（大风车）
id = 118：空中回转攻击落地
id = 100，101，102：跳跃蓄力攻击（100一蓄，101二蓄，102三蓄）
id = 122，123：斜坡滑行，123为滑行一定时间后加速
```
#### 强化射击，钩爪派生
```text
id = 134：蓄力中的强化射击
id = 137，138：二蓄升龙，三蓄敲打等终结技派生的发射钩爪动作，137为准备发射，138为发射钩爪到收回
id = 141，142：二蓄钩爪派生的正常上身
id = 140：旋转飞扑攻击（追踪大风车）
id = 42：武器软化动作
```
### 狩猎笛（武器编号：5）
#### 攻击动作
```text
id = 74：拨浪鼓
```
#### 演奏动作
```text
id = 77：开始演奏
id = 81：开始向前演奏
id = 88：演奏完成
id = 98，92：二次吹奏
id = 90：完成吹奏
id = 87：向前吹奏
id = 102，97：向前第二次吹奏
```
### 长枪（武器编号：6）
#### 攻击动作
```text
id = 69，70，71：斜戳三段
id = 65，66，67：平戳三段
id = 73，74，75：横扫三段（衔接在三连戳的起手，一段和二段戳刺后派生）
id = 83：反击突刺
id = 84：人车起手
id = 85：人车状态
id = 105：一段人车终结突刺
id = 106：二段人车终结突刺
id = 124：人车撞墙
id = 101，102：人车回马枪（102估计是收招）
id = 107，158:飞身跃入突刺（方唐镜）
```
#### 防御动作
```text
id = 35，36，37：防御的小退，中退，大退
id = 78，79，80，81，82：反击突刺架势的防御反应（78，79小退，90，81中退，82大退）
id = 39：力防防御反应、
id = 138，139，140：力量防御起手，防御状态，结束防御
id = 76：反击架势
id = 96，97，98，99:四向盾突（96前，97左，98右，99后）
```
#### 钩爪派生，强化射击等
```text
id = 160: 钩爪反击架势（爪反）
id = 163，164：爪反被击中起飞（163）以及钩爪追击至怪物的动作（164）
id = 151: 强化射击防御
```
### 铳枪（武器编号：7）
#### 体术类
```text
id = 79: 上挑
id = 83: 下砸
id = 85: 横扫
id = 90: 踏步上突刺（突进上捞斩）
id = 73，75，77: 三连戳
id = 126，128，130: 三段防御突刺
```
#### 炮击类
```text
id = 92，94。96: 普通炮击（96上，94中，92下三个方向）
id = 98，100，102: 蓄力炮击（102上，100中，98下三个方向）
id = 87，88，89: 龙杭炮发射预备动作（87下，88中，89上三个方向）
id = 110，112，114: 龙杭炮发射动作（110下，112中，114上三个方向）
id = 104: 全弹发射
id = 158，160: 空中全弹发射
id = 106: 龙击炮
id = 164，165，166：发射起爆龙杭（164下，165中，166上三个方向）
```
#### 弹药管理
```text
id = 116：普通装填
id = 167：起爆龙杭装填
注：快速装填动作为所有能执行快速装填的动作的fsm数值+1，动作数量过多就不赘述了，仅在此给用户阐述快速装填的fsm规律
```
### 斩斧（武器编号：8）
#### 斧形态
```text
id = 71：上捞斩
id = 70：直斩
id = 75，76：挥旋，挥旋停止
id = 136：强化敲打
```
#### 剑形态
```text
id = 111：二连斩
id = 112：横斩
id = 113：飞天二连斩
id = 118：属性解放突刺
id = 119：属性解放突刺连按充能
id = 121：属性解放终结
id = 122：简易属性解放终结
id = 133：钩爪抱脸，零距离突刺
id = 124，134：零解上脸连按
id = 125：零解终结
id = 126：简易零解终结
id = 127：零解落地
id = 138：突刺钩爪派生
```
#### 变形部分
```text
id = 105：斧变剑
id = 106：突进斧变剑
id = 72：剑变斧
id = 117：剑变斧：翻滚变形
id = 77：横扫变形斩（前段大回环）
id = 78：斧变剑：原地变形
id = 115：剑变斧：原地变形
id = 80：装瓶
```
### 盾斧（武器编号：9）
#### 剑形态
```text
id = 70：回转斩击
id = 72：蓄力
id = 74：蓄力二连斩
id = 80：开红剑蓄力
id = 81：高压属性斩（开红剑）
id = 108：装瓶
id = 101：盾突
id = 76，77，78，79：四方向移动斩（位移很大，76前，77后，78左，79右）
id = 34：剑弹刀
```
#### 斧形态
```text
id = 112：突进敲打
id = 110：上捞斩
id = 111：下砸
id = 114：一解
id = 116：二解
id = 118：大解
id = 120：超解
id = 117，119：大解，超解前摇（117无红盾，119有红盾）
```
#### 变形部分
```text
id = 106：剑变斧
id = 71：斧变剑
```
#### 强化部分
```text
id = 81：高压属性斩（开红剑）
id = 109：属性强化回旋斩（开红盾）
id = 148：属性回填斧强化斩（开电锯）
tips: 目前因为开电锯时存在延迟输入帧（就是可以在超解动作开始时的约0.2秒内按钩爪键可以把超解动作转换为开电锯的动作），导致开电锯按晚了会有超解文本发送，该问题请等待mod作者更新。
```
### 操虫棍（武器编号：10）
#### 地面动作
```text
id = 65：飞身跃入斩
id = 66：回避斩
id = 75：强化二连斩
id = 76：强化横扫斩
id = 77：连续上捞斩
id = 78：飞圆斩
id = 80：虫印斩
id = 81，82：发射虫印弹
id = 83：站姿收放虫（移动收放虫时只有武器模型位置发生变换，不被计入fsm）
id = 85，86，87，88：无白灯四向起跳（前85，左86，右87，后88）
id = 89，90，91，92：白灯四向起跳（前89，左90，右91，后92）
id = 133：猎虫强化
```
#### 空中动作
```text
id = 107，108，109，110：无白灯四向空中回避（前107，左108，右109，后110）
id = 111，112，113，114：四向空中回避（前111，左112，右113，后114）
id = 106：跳跃突进斩击中后派生的滞空态
id = 116：跳跃突进斩
id = 117：强化跳跃突进斩（小飞棍最爱的那个）
id = 13：跳跃斩
id = 115：强化跳跃斩（骑乘值很高）
id = 14：急袭突刺（下戳）
id = 129：空中钩爪派生
id = 131：空中钩爪派生命中
id = 132：下戳落地派生虫印连段
```
### 弓箭（武器编号：11）
#### 射击
```text
id = 74：满蓄力平射
id = 75：刚射
id = 76：吊射
id = 77：拔刀龙矢蓄力
id = 78：拔刀龙矢发射
id = 79：迅雷闪击
id = 83：飞身跃入近身攻击起手（飞身箭斩）
id = 84：飞身跃入近身攻击后摇
id = 111：龙之千矢发射准备动作
id = 112：龙之千矢发射动作
```
#### 移动与瞄准相关
```text
id = 65：抬手瞄准
id = 66：瞄准中移动
id = 67：瞄准时停止移动
id = 68：站立状态下停止瞄准
id = 22：后跳
id = 85，86，87，88：四向滑步（85前，86后，87左，88右）
```
### 重弩炮（武器编号：12）
#### 常规弹药
```text
id = 35, 36, 37：带盾重弩防御动作（35小退，36中退，37大退）
id = 65：抬手瞄准
id = 66：站立状态下停止瞄准
id = 67：站立瞄准
id = 69：瞄准中移动
id = 71：瞄准时停止移动
id = 72：射击后摇：后坐力（大）
id = 73：射击后摇：后坐力（特大）
id = 78：换弹：装填速度（稍微慢）
id = 79：换弹：装填速度（慢）
id = 106：近身攻击（Manba OUT!）
id = 118：安装/卸下超级会心镜
```
#### 特殊弹药
```text
id = 77：龙击炮蓄力
id = 76：龙击炮发射
id = 85：扩散弹准备瞄准
id = 86：扩散弹取消瞄准
id = 87：扩散弹瞄准中
id = 88：扩散弹发射（后坐力：小）
id = 89：扩散弹发射（后坐力：中）
id = 90：扩散弹发射（后坐力：大）
id = 80：装备特殊弹药
id = 95：狙击龙弹准备瞄准
id = 96：狙击龙弹取消瞄准
id = 97：狙击龙弹瞄准中
id = 98：狙击龙弹发射
注：机关龙弹无特殊动作，故没有fsmid
```
### 轻弩炮（武器编号：13）
#### 射击相关
```text
id = 65：抬手瞄准
id = 66：站立状态下停止瞄准
id = 67：站立瞄准
id = 69：瞄准中移动
id = 71：瞄准时停止移动
id = 72：射击后摇：后坐力（大）
id = 73：射击后摇：后坐力（特大）
id = 74：速射（后坐力：大）
id = 75：速射（后坐力：特大）
id = 78：换弹：装填速度（稍微慢）
id = 79：换弹：装填速度（慢）
id = 99：近身攻击（What can I say）
id = 112：起爆龙弹
id = 113：反击龙弹
```
#### 回避类动作相关
```text
id = 104，105，106，107：四向一段滑步（104前，105后，106左，107右）
id = 108，109，110，111：四向二段滑步（108前，109后，110左，111右）
注：回避装填是武器模型相对位置的改变，不改变人物动作
```

### 全局fsm（测的是fsm target = 1，即纳刀态以及硬直类数据，有待补充）
```text
id = 325:猫车
id = 361:正面被击飞（小起身后摇）
id = 362:背面被击飞（小起身后摇）
id = 360:背面被击飞（大起身后摇，可装死）
id = 359:正面被击飞（大起身后摇，可装死）
```
## 本表部分数据由mod群*259616154*内群友***璀云霄***测出，相关数据已由Stellaraven验证并更正部分错误，并做出了大量的动作补充及其说明，若有除表内动作之外的动作检测需求，可向笔者反馈。
# Thanks For Your Reading
